#!/bin/sh
###########################
# Ical-Agenda-Sript 0.1
# by musicus 01.01.2019
# getestet mit Rainlendar2 + iCalendar-Plugin
###########################


############ >>> Adresse der Ical-Datei hier eintragen <<< ###############
ICS=`echo /mnt/mnt0/tuxcal/test.ics`
############ >>> Adresse der Ical-Datei hier eintragen <<< ###############




msgbox popup="  Bitte warten..." title="Agenda-Kalender" size=32 timeout=1


y=`date +%Y`
v=`expr $y + 1`
w=`expr $y + 2`
t=`date +"%d.%m.%Y %T"`


echo "FONT=/share/fonts/micron_bold.ttf" > /var/tuxbox/config/agenda.conf
echo "FONTSIZE=25" >> /var/tuxbox/config/agenda.conf
echo "HEIGHT=680" >> /var/tuxbox/config/agenda.conf
echo "WIDTH=1100" >> /var/tuxbox/config/agenda.conf
echo "LINESPP=20" >> /var/tuxbox/config/agenda.conf
echo "PAGING=1" >> /var/tuxbox/config/agenda.conf
echo "MENU=Ical Agenda (Stand: $t)" >> /var/tuxbox/config/agenda.conf
echo "ACTION=*Kalender-Stand aktualisieren,/var/tuxbox/plugins/ical2agenda1.sh &" >> /var/tuxbox/config/agenda.conf


cat $ICS |
sed -e '/:VEVENT/b' -e '/DTSTART/b' -e '/DTEND/b' -e '/SUMMARY:/b' -e '/CATEGORIES:/b' -e '/:VTODO/b' -e '/RRULE:/b' -e d  |
sed '/^END:V/!s/.$/=/g' |
sed -e :a -e '/\=$/N; s/\=\n/@/; ta' |
sed '/VTODO/d' > /tmp/aglist.txt


cat /tmp/aglist.txt | sed '/YEARLY/!d' > /tmp/aglistgeb.txt
sed -i '/YEARLY/d' /tmp/aglist.txt

GL=`cat /tmp/aglistgeb.txt | sed 's/ //g'`
for ZZ in $GL
do
BTH=`echo $ZZ | sed 's/.*VALUE=DATE:\(....\).*/\1/g'`
JJ=`expr $y - $BTH`
echo $ZZ | sed '/Geburtstag\|Birthday/s/SUMMARY:/& ('$JJ'\.) /g' | 
sed 's/VALUE=DATE:..../VALUE=DATE:'$y'/g' |
sed 's// /g' >> /tmp/aglistg1.txt
done

sed -i 's/\(.*\)/\1\n\1/g' /tmp/aglistg1.txt
sed -i '/^/s/'$y'/'$v'/g' /tmp/aglistg1.txt

#fr Zeilen mit  den Geburtstag +1 erhhen

GL=`cat /tmp/aglistg1.txt | sed 's/ /qq/g'`
for ZZ in $GL
do
BO=`echo $ZZ | sed '/^/s/.*qq(\(.*\)\.)qq.*/\1/g'`
BN=`expr $BO + 1`
echo $ZZ | sed '/^/s/\(.*\)qq(\(.*\)\.)qq\(.*\)/\1qq('$BN'\.)qq\3/g' |
sed 's/qq/ /g' |
sed 's///g' >> /tmp/aglist.txt
done

cat /tmp/aglist.txt |
sed 's/\(.*\)\(DTSTART.*@\)\(.*\)/\2\1\3/' |
sed 's/VALUE=DATE//g; s/-TIME//g; s/DTSTART//g; s/RRULE.*@//g; s/;//g; s/SUMMARY:/  /g; s/CATEGORIES:/  ~T920 [/g; s/@END:VEVENT/]/g; s/DTEND:/-  /g; s/@BEGIN:VEVENT//g; s/@/  /g' |
sed -e /^:$y/b -e /^:$v/b -e /^:$w/b -e d |
sort |
grep -n '.*' > /tmp/aglist3.txt

cat /tmp/aglist3.txt | sed -e 's/^\(.*:\):.*-  \([0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]\).*/\1\2/g' > /tmp/aglist2.txt
TUM=`cat /tmp/aglist2.txt`

for ZEILE in $TUM
do
TUMNUM=`echo $ZEILE | sed 's/\(.*\):.*/\1/g'`
DATAUS=`echo $ZEILE | sed 's/^.*:\([0-9][0-9][0-9][0-9]\)\([0-9][0-9]\)\([0-9][0-9]\)/\1\-\2\-\3/g'`
GAT=`date --date=$DATAUS' 01:00:00' +%s`
GESTERN=`expr $GAT - 86400`
GESGAT=`date -d @$GESTERN +%Y%m%d`

sed -i '/^'$TUMNUM':/s/  -  .*    \([^~].*\)/  -  '$GESGAT'    \1/g' /tmp/aglist3.txt

HEUTE=`date +%Y%m%d`

if [ $GESGAT -lt $HEUTE ]; then
sed -i 's/^'$TUMNUM':/xxx/g' /tmp/aglist3.txt
fi
done

cat /tmp/aglist3.txt | 
sed /^xxx/d |
sed 's/^.*:\(:.*\)/\1/g' |
sed 's/\([0-9][0-9][0-9][0-9]\)\([0-9][0-9]\)\([0-9][0-9]\)/\3\.\2\.\1/g' |
sed 's/\[\(Geburtstag\)\]/[~G\1~S]/g' |
sed 's/\[\(Birthday\)\]/[~G\1~S]/g' |
sed 's/Dringend/~R&~S/g' |
sed 's/\[\(Ferien\)\]/[~Y\1~S]/g' |
sed 's/^:/ACTION=\*~S/g' >> /var/tuxbox/config/agenda.conf
echo "ENDMENU" >> /var/tuxbox/config/agenda.conf

msgbox popup="  Kalender aktualisiert..." size=32 timeout=1

shellexec /var/tuxbox/config/agenda.conf

rm /tmp/aglist.txt 
rm /tmp/aglist2.txt 
rm /tmp/aglist3.txt
rm /tmp/aglistgeb.txt
rm /tmp/aglistg1.txt
 
exit 0;
 